#version 330

in vec3 position;
in vec3 normal;
in vec2 uv;

in vec3 tangent;
in vec3 bi_tangent;



out vec2 fragmentUV;
out vec3 P;
out mat3 localSurface2World;



uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;





void main(){
	
	fragmentUV = uv;
	mat4 normalMatrix = inverse(transpose(modelMatrix));

	vec3 worldTangent = normalize( ((modelMatrix * vec4(tangent, 0.0f )).xyz) );
	vec3 worldNormal = normalize( (modelMatrix * vec4(normal, 0.0f )).xyz );
	
	P = ( modelMatrix * vec4(position, 1) ).xyz;

	// calculate TBN Matrix

	localSurface2World[0] = worldTangent;														// TANGENT

	localSurface2World[2] = worldNormal;														// NORMAL
	
	localSurface2World[1] = normalize(cross(localSurface2World[2], localSurface2World[0]));		// BITANGENT = TANGENT x NORMAL

	gl_Position = projectionMatrix  * modelMatrix * vec4(position, 1);
}