#version 330




in vec3 position;
in vec3 normal;
in vec2 uv;
in vec3 color;


out vec3 P;
out vec3 N;
out vec2 fragmentUV;
out vec3 C;


uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;



void main() {
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1.0f);
	fragmentUV = uv;
	mat4 normalMatrix = transpose(inverse(modelMatrix));
	vec3 worldNormal = normalize( (vec4(normal, 0.0f) * normalMatrix).xyz); // evtl. nur InverseModelMatrix???
	
	
	N = worldNormal;
	P = ( modelMatrix * vec4(position, 1.0f) ).xyz;
	C = color;
}
